package com.integ.common.utils;



public class ObjectUtils {

    public static String getString(Object o, String defaultValue) {
        String s = defaultValue;
        if (null != o) s = (String) o;
        return s;
    }



    public static boolean getBoolean(Object o, boolean defaultValue) {
        boolean b = defaultValue;
        if (o != null) {
            if (o instanceof Boolean) b = ((Boolean) o).booleanValue();
            else b = (Boolean.valueOf((String) o)).booleanValue();
        }
        return b;
    }



    public static int getInt(Object o, int defaultValue) {
        int i = defaultValue;
        if (o != null) {
            String s = (String) o;
            if (s.length() > 0) i = Integer.parseInt((String) o);
        }
        return i;
    }



    public static long getLong(Object o, long defaultValue) {
        long l = defaultValue;
        if (o != null) {
            String s = (String) o;
            if (s.length() > 0) l = Long.parseLong((String) o);
        }
        return l;
    }



    public static double getDouble(Object o, double defaultValue) {
        double d = defaultValue;
        if (o != null) d = Double.valueOf((String) o).doubleValue();
        return d;
    }
}
